﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace MainForm.Control
{
	public partial class LoadingForm : Form
	{
		private System.Windows.Forms.Timer timer = new System.Windows.Forms.Timer();

		public object Param { get; set; }
		public Func<object, object> Function { get; set; }
		public object Result { get; set; }

		public LoadingForm(Form owner)
		{
			InitializeComponent();
			InitInstance(owner);
		}

		private void InitInstance(Form owner)
		{
			this.Owner = owner;
			this.TopMost = true;

			timer.Interval = 50;
			timer.Tick += Timer_Tick;
			this.CenterToParent();
			this.Shown += LoadingForm_Shown;
		}

		private void LoadingForm_Shown(object sender, EventArgs e)
		{
			timer.Start();

			Thread thread = new Thread(() => {
				if (this.Function == null)
					return;

				this.Result = this.Function.Invoke(this.Param);
				this.Invoke((Action)(() => {
					this.Close();
				}));
			});
			thread.Start();
		}

		private void Timer_Tick(object sender, EventArgs e)
		{
			if (progressBar.Value >= 100)
				progressBar.Value = 0;
			else
				progressBar.Value++;
		}
	}
}
